#!/usr/bin/env  php
<?php
//////////////////////////////////////////////////////////////////////
//
//      Projekt:   OutDatedSoftware (looks for outdated Software like typo3, joomla, wordpres.... and more)
//      Datei:     main.php
//      Version:   see $config['mainversion']
//      Datum:     21.02.2009
//      Author:    Martin Schiftan
//      Descr.:    Prueft im angegebenen Verzeichnis ob veraltete Web-Applicationen gefunden wurden und ob diese aktuell sind
//      license:   private (Update der Versionsnummer/Module kostenpflichtig)
//
//////////////////////////////////////////////////////////////////////
error_reporting(0);
ini_set('display_errors', 'Off');
ini_set('max_execution_time', 0);
ini_set('memory_limit', '50000M');
#ini_set('error_log', 'php.log');
@date_default_timezone_set(date_default_timezone_get());

$starttime                    = time();
$config['url']['updates']     = 'http://dl.outdated.software/{$lang}/updates.tar.gz';
$config['url']['updatesmd5']  = 'http://dl.outdated.software/{$lang}/updates.tar.gz.md5';
$config['url']['version']     = 'http://dl.outdated.software/{$lang}/updateversion.txt';
$config['url']['mainversion'] = 'http://dl.outdated.software/{$lang}/mainversion.txt';
$config['url']['mainupdate']  = 'http://dl.outdated.software/{$lang}/latest.tar.gz';
$config['url']['mainupdate5'] = 'http://dl.outdated.software/{$lang}/latest.tar.gz.md5';
$config['url']['stats']       = 'http://dl.outdated.software/{$lang}/stats.html';
$config['mainversion']        = '3.4.329';
$config['home']               = dirname(__FILE__).DIRECTORY_SEPARATOR;
$config['createcronfile']     = 0;
$p                            = DIRECTORY_SEPARATOR;
$n                            = "\n";
if(php_sapi_name() != 'cli')
  {
    $n = '<br />';
  }

if((isset($_REQUEST['cronjob'])) && (!isset($_REQUEST['manuell'])))
  {
    $configs['color'] = 'off';
  }

if(!file_exists($config['home'].'classes/Checker.class.php'))
  {
    exit("\nERROR: File classes/Checker.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/Checker.class.php';
if(!file_exists($config['home'].'classes/Config.class.php'))
  {
    exit("\nERROR: File classes/Config.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/Config.class.php';
if(!file_exists($config['home'].'classes/Filestuff.class.php'))
  {
    exit("\nERROR: File classes/Filestuff.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/Filestuff.class.php';
if(!file_exists($config['home'].'classes/Updater.class.php'))
  {
    exit("\nERROR: File classes/Updater.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/Updater.class.php';
if(!file_exists($config['home'].'classes/ModulesClasses.class.php'))
  {
    exit("\nERROR: File classes/ModulesClasses.class.php NOT found!\n");
  }
@require_once $config['home'].'classes/ModulesClasses.class.php';
if(!file_exists($config['home'].'classes/Statistics.class.php'))
  {
    echo("\nERROR: File classes/Statistics.class.php NOT found! But is only needed, when you have activated it in the config file.\n");
  }
@require_once $config['home'].'classes/Statistics.class.php';



ob_implicit_flush(true);
@ob_end_flush();
register_shutdown_function('shutdown');

if((isset($_REQUEST['update'])) || (@$argv[1] == 'update'))
  {
    $config['autoupdates'] = 1;
  }
if((isset($_REQUEST['cronjob']) && !isset($_REQUEST['manuell'])) || (!isset($_SERVER['TERM'])))
  {
    $config['color'] = 0;
  }



$main = new Run($config);
        $main->SetHome($config['home']);




$main->debug('check which php-form (cgi/modul/cli) are installed');
$phpmodul    = php_sapi_name();

if((isset($argv[1])) && (!empty($argv[1])))
  {
    $phpmodul = 'cli';
    $n        = "\n";
  }
if($phpmodul == 'cli')
  {
# argv
    if((isset($argv[1])) && (!empty($argv[1])) && ($argv[1] != $_SERVER['PHP_SELF']))
      {
        $argv['path'] = $_REQUEST['path'] = $argv[1];
      }
    $_REQUEST  = $argv;
    foreach($argv as $key => $value)
      {
        if(stripos($value, '='))
          {
            $vals               = explode('=', $value);
            $_REQUEST[$vals[0]] = $vals[1];
          }
        else
          {
            if((!isset($value)) || (empty($value)))
              {
                $_REQUEST[$key]   = $key;
              }
            elseif((is_numeric($key)) && (!empty($value)))
              {
                $_REQUEST[$value] = $value;
              }
          }
      }
  }
elseif(stripos($phpmodul, 'cgi') !== FALSE)
  {
    $n = '<br />';
# request
    if((isset($_REQUEST[2])) && (!empty($_REQUEST[2])))
      {
        $_REQUEST['path'] = $_REQUEST[2];
      }
    foreach($_REQUEST as $key => $value)
      {
        if(!isset($_REQUEST['path']))
          {
            $_REQUEST['path'] = $key;
          }
        if(stripos($value, '='))
          {
            $vals               = explode('=', $value);
            $_REQUEST[$vals[0]] = $vals[1];
          }
        else
          {
            if((!isset($value)) || (empty($value)))
              {
                $_REQUEST[$key]   = $key;
              }
            elseif((is_numeric($key)) && (!empty($value)))
              {
                $_REQUEST[$value] = $value;
              }
          }
      }
  }

# fix for older versions
if(isset($_REQUEST['pfad']))
  {
    $_REQUEST['path'] = $_REQUEST['pfad'];
  }

# check server pwd, if no path given
if((@$argc == 1) || (!isset($_REQUEST['path'])))
  {
    $_REQUEST['path'] = getcwd();
  }
if($_REQUEST['path'] == '.'.$p)
  {
    $_REQUEST['path'] = getcwd();
  }
if(substr_count($_REQUEST['path'], -1) != DIRECTORY_SEPARATOR)
  {
    $_REQUEST['path'] .= DIRECTORY_SEPARATOR;
  }

# Weblogin
if($phpmodul != 'cli')
  {
    # make css and login page.....
  }






$languages = $main->GetLanguages(1);
# check params
if((!isset($_REQUEST['cronjob'])) || (!isset($_SERVER['TERM'])) || (isset($_REQUEST['manuell'])))
  {
    echo $languages['started'];
    flush();
  }
if($main->config['usecronjob'] == 1)
  {
    if((!isset($_REQUEST['cronjob'])) || (isset($_REQUEST['manuell'])))
      {
        $_REQUEST['man'] = 1;
        $languages = $main->GetLanguages($main->config['color']);
      }
    $_REQUEST['cronjob'] = 1;
    $_REQUEST['manuell'] = 1;
    $main->debug('Using cronjobfile if usecronjob in config activated...');
  }


# load languages and updates
if($main->config['autoupdates'] == 1)
  {
    $main->debug('run self updater');
    $main->RunSelfUpdater();
  }
if($main->config['format'] != 'text')
  {
    unset($languages);
    $languages = $main->GetLanguages(0);
  }
$main->debug('get languages and configs');
$header    = $languages['header'];




# if Only updateing
if((isset($_REQUEST['update'])) || (isset($_REQUEST['forceupdate'])))
  {
    $updated = $main->RunSelfUpdater();
    $output  = ReplaceColors($n."{GREEN}".$languages['listversion']."{/GREEN}".$n);
    $modulv  = $main->GetModulesVersion();
    $mainv   = $main->GetMainVersion();
    if(($updated == 2) || ($mainv != $main->config['oldmainversion']))
      {
        $mainv = $main->GetMainVersion();
        unset($_REQUEST[0]);
        pcntl_exec($_SERVER['SCRIPT_NAME'], $_REQUEST);
      }
    if($modulv == $main->config['oldmodulversion'])
      {
        $oldu = $modulv.' (UpToDate)';
      }
    else
      {
        $oldu = $modulv.' (Old: '.$main->config['oldmodulversion'].')';
      }
    if($mainv == $main->config['oldmainversion'])
      {
        $oldm = $mainv.' (UpToDate)';
      }
    else
      {
        $oldm = $mainv.' (Old: '.$main->config['oldmainversion'].')';
      }
    $output .= $n.$languages['modulversion']."            ".$oldu;
    $output .= $n.$languages['mainversion']."              ".$oldm;
    $output .= $n.$languages['searchcounts']."    ".$main->GetCountModules().$n.$n.$n;
    die($output);
  }



# Only display the modules and versions
if(isset($_REQUEST['list']))
  {
    $output  = ReplaceColors($n."{GREEN}".$languages['listversion']."{/GREEN}".$n);
    $output .= $n.$languages['modulversion']."            ".$main->GetModulesVersion();
    $output .= $n.$languages['mainversion']."              ".$main->GetMainVersion();
    $output .= $n.$languages['searchcounts']."    ".$main->GetCountModules().$n.$n.$n;
    $show    = 0;
    $modules = $main->GetModules();
    if(($modules <= 0) || (!is_array($modules)))
      {
        $main->fehler('nomodules2');
      }
    if((isset($argv[2])) && (!isset($_REQUEST['modul'])))
      {
        $_REQUEST['modul'] = $argv[2];
      }
    foreach($modules as $key => $value)
      {
        if((isset($_REQUEST['modul'])) && ($value['software'] == $_REQUEST['modul']))
          {
            $show = 1;
          }
        if(($show == 1) || (!isset($_REQUEST['modul'])))
          {
            $output .= $languages['modul']."       ".$value['software'].$n;
            $output .= $languages['latest']."      ".$value['aktuell'].$n;
#			$output .= $languages['modulefile']."  ".$value['datei'].$n;
            $output .= $n;
            $show   = 0;
          }
      }
    die($output);
  }



# Only display the help
if((isset($_REQUEST['help'])) || (isset($_REQUEST['--help'])) || (isset($_REQUEST['-h'])) || (isset($_REQUEST['--h'])))
  {
    $output  = $languages['help'];
    $output .= ' '.$languages['listversion'].$n;
    $output .= $n." ".$languages['modulversion']."            ".$main->GetModulesVersion();
    $output .= $n." ".$languages['mainversion']."              ".$main->GetMainVersion();
    $output .= $n." ".$languages['searchcounts']."    ".$main->GetCountModules().$n.$n.$n;
    die($output);
  }

#
# Help output stuff end
# Now, the normal program starts
#




# normal logic, found path and go on
if((!isset($_REQUEST['path'])) || (empty($_REQUEST['path'])))
  {
    if(isset($_REQUEST['pfad']))
      {
        $_REQUEST['path'] = $_REQUEST['pfad'];
      }
    $main->pfad = $_SERVER['PWD'];
  }
elseif((isset($_REQUEST['path'])) && (!empty($_REQUEST['path'])))
  {
    $main->pfad = $_REQUEST['path'];
  }

if(substr($main->pfad, 0, 1) == '.')
  {
    $main->pfad = $_SERVER['PWD'].$p.$main->pfad;
  }
if(substr($main->pfad, -1) != $p)
  {
    $main->pfad .= $p;
  }
if(!is_dir($main->pfad))
  {
    $main->fehler('dirnotfound', $main->pfad);
    die();
  }
if(function_exists('posix_access'))
  {
    if(!posix_access($main->pfad, POSIX_R_OK))
      {
        $main->fehler('nopermissions', $main->pfad);
      }
  }


if(isset($_REQUEST['format']))
  {
    $main->config['format'] = $_REQUEST['format'];
    if($main->config['format'] != 'text')
      {
        $languages = $main->GetLanguages(0);
        $header    = $languages['header'];
      }
  }
if(isset($_REQUEST['color']))
  {
    if(is_numeric($_REQUEST['color']))
      {
        $languages = $main->GetLanguages($_REQUEST['color']);
        $header    = $languages['header'];
      }
  }

$trial = '';
if($main->config['key'] == '0123456789')
  {
    $trial = ' !!! TRIAL / TEST Version !!!';
  }

$header    = str_replace('{COUNTMODULE}', $main->GetCountModules(), $header);
$header    = str_replace('{SUCHPFAD}', $main->pfad, $header);
$header    = str_replace('{MAINVERSION}', $main->GetMainVersion(), $header);
$header    = str_replace('{UPDATEDVERSION}', $main->GetModulesVersion().$trial, $header);
$header    = str_replace('{DATUM}', date('Y-m-d H:i:s O', $starttime), $header);
if(!isset($_REQUEST['blacklist']))
  {
    $_REQUEST['blacklist'] = '';
  }
$header    = str_replace('{BLACKLIST}', @$_REQUEST['blacklist'], $header);


if((isset($_REQUEST['cronjob'])) && ($main->config['format'] != 'text'))
  {
    $output2['countmodule'] = $main->GetCountModules();
    $output2['searchdir']   = $main->pfad;
    $output2['mainversion'] = $main->GetMainVersion();
    $output2['signatur']    = $main->GetModulesVersion().$trial;
    $output2['date']        = date('Y-m-d H:i:s O');
    $output2['blacklist']   = @$_REQUEST['blacklist'];
  }

$footer = $languages['footer'].$trial;











# Started Programm with all required variables



$main->GetModules();
$main->debug('got '.$main->GetCountModules().' software-modules');
if(isset($_REQUEST['modul']))
  {
    $modul = strtolower($_REQUEST['modul']);
    if(!in_array($modul, $main->GetModulesNames()))
      {
        $main->fehler('searchmodulnotexists', $modul);
      }
  }
elseif((isset($argv[3])) && ($argv[3] != 'cronjob') && (stripos($argv[2], 'blacklist') !== FALSE) && (stripos($argv[3], 'blacklist') !== FALSE))
  {
    $modul = strtolower($argv[3]);
    if(!in_array($modul, $main->GetModulesNames()))
      {
        $main->fehler('searchmodulnotexists', $modul);
      }
  }
else
  {
    $modul = NULL;
  }

$main->debug('starting for modul: "'.$modul.'" (empty is all modules)');
$main->debug('can be need a while..... a long while, a really long time....');

$modul2 = $modul;
if(empty($modul))
  {
    $modul2 = '*';
  }

$files = $main->GetFilesList($modul);
         $main->debug('get files for modul "'.$modul2.'"');
$count = $main->GetNumFiles();
         $main->debug('got '.$count.' files for searching for '.$modul2);

$main->debug('loaded modul-files done');

$version = $main->CheckFile();
           $main->debug('checking files for pattern in the modules for the file-names');
if(is_array($version))
  {
    $count  = count($version);
    $output = '';
    for($i = 0; $i < $count; $i++)
      {
#        $main->debug('Checking file '.dirname($version[$i]['file']).' for modul '.$version[$i]['modul']);
        if($main->checkfileversion($version[$i]['file'], $version[$i]['modul']) == 0)
          {
            $funde   = $main->GetResults($version[$i]['file']);
            if((stripos($funde['old'], 'Installed Version is newer') !== FALSE) && ($main->config['listnew'] == 0))
              {
                $main->counter--;
                continue;
              }
            $output .= $n;
            if((isset($main->config['listupdated'])) && ($main->config['listupdated'] == 1) && (@$funde['uptodate'] == 1))
              {
                $output .= $languages['fund1']."        ".$funde['file'].$n;
                $output .= $languages['modul']."         ".$funde['software'].$n;
                $output .= $languages['old']."     ".$funde['old']." (UpToDate)".$n;
              }
            else
              {
                $output .= $languages['fund']."        ".$funde['file'].$n;
                $output .= $languages['modul']."         ".$funde['software'].$n;
                $output .= $languages['old']."     ".$funde['old'].$n;
              }
            $output .= $languages['latest']."        ".$funde['new'].$n;
            $output .= $n;
            $main->debug('Modul '.$version[$i]['modul'].' matcht for file '.dirname($version[$i]['file']));
            if((isset($_REQUEST['cronjob'])) && (!isset($_REQUEST['man'])))
              {
                if(@$main->config['format'] != 'text')
                  {
                    $languages = $main->GetLanguages(0);
                  }
                $languages['fund']       = trim(str_replace(':', '', $languages['fund']));
                $languages['modul']      = trim(str_replace(':', '', $languages['modul']));
                $languages['old']        = trim(str_replace(':', '', $languages['old']));
                $languages['latest']     = trim(str_replace(':', '', str_replace('/', '', $languages['latest'])));
                $output3[$funde['file']] = array($languages['fund'] => $funde['file'], $languages['modul'] => $funde['software'], $languages['old'] => $funde['old'], $languages['latest'] => $funde['new']);
              }
          }
      }
  }
else
  {
    $output = '';
  }


$uptodate = $main->GetResultsUpToDate();
if(is_array($uptodate))
  {
    $uptodate = count($uptodate);
  }
$olds =  $main->GetNumOld();
if((isset($main->config['listupdated'])) && ($main->config['listupdated'] == 1))
  {
    $olds = $olds - $uptodate;
  }
$all = $uptodate + $olds;

$footer = str_replace('{UPTODATE}', $uptodate, $footer);
$footer = str_replace('{FUNDE}', $olds, $footer);
$footer = str_replace('{ALL}', $all, $footer);
$minus  = time() - $starttime;
$footer = str_replace('{ENDE}', date('Y-m-d H:i:s O').' ('.$minus.' Seconds)', $footer);
$header = str_replace('{UPTODATE}', $uptodate, $header);
$header = str_replace('{ALL}', $all, $header);




$main->debug('give results out (for cronjob, manuell or normal mode...)');

if(!isset($_REQUEST['cronjob']))
  {
   if((isset($modul)) && (!empty($modul)))
      {
        $suchmodul = $modul;
      }
    else
      {
        $suchmodul = $languages['searchmodul'];
      }
    $header = str_replace('{SUCHMODULE}', $suchmodul, $header);
    if((!is_array($version)) || ($b <= 0))
      {
        echo str_replace('{FUNDE}', '0', $header);
      }
    else
      {
        echo str_replace('{FUNDE}', $$olds, $header);
        echo $output;
      }
    echo $footer;
    $main->debug('send stats if activated in config');
    $main->sendStats($main->GetResultsUpToDate(), $main->GetResultsOld());
    cleaning($main);
    exit(0);
  }
elseif(isset($_REQUEST['cronjob']))
  {
   if((isset($modul)) && (!empty($modul)))
      {
        $suchmodul = $modul;
      }
    else
      {
        $suchmodul = $languages['searchmodul'];
      }
    $header                  = str_replace('{SUCHMODULE}', $suchmodul, $header);
    $output2['searchmodule'] = $suchmodul;
    if((!is_array($version)) || ($olds <= 0))
      {
        $header = str_replace('{FUNDE}', '0', $header);
        $output3= 0;
      }
    else
      {
        $header = str_replace('{FUNDE}', $olds, $header);
      }
    if(!isset($output3))
      {
        $output3 = 0;
      }
    switch($main->config['format'])
      {
        case 'php':
          echo serialize(array('header' => $header, 'settings' => $output2, 'result' => $output3, 'uptodate' => $main->GetResultsUpToDate(), 'footer' => $footer));
        break;

        case 'json':
          echo json_encode(array('header' => $header, 'settings' => $output2, 'result' => $output3, 'uptodate' => $main->GetResultsUpToDate(), 'footer' => $footer));
        break;

        case 'csv':
          $output = fopen('php://output', 'w');
          fputs($outout, array('header' => $header, 'settings' => $output2, 'result' => $output3, 'uptodate' => $main->GetResultsUpToDate(), 'footer' => $footer));
          fclose($output);
        break;

        case 'xml':
        break;

        case 'text': default:
          echo $header.$output.$footer;
        break;
      }
    $main->debug('send stats if activated in config');
    $main->sendStats($main->GetResultsUpToDate(), $main->GetResultsOld());
    cleaning($main);
    exit(0);
  }






function shutdown()
  {
    global $main;
    if((isset($main->pid)) && ($main->pid >= 100))
      {
        shell_exec('kill -9 '.$main->pid);
        if(!isset($_REQUEST['cronjob']))
          {
            @unlink($main->findfile);
          }
      }
  }

function cleaning($main)
  {
    $main->debug('cleaning tmp files');
    @unlink($main->findfile);
    if(strtoupper(substr(PHP_OS, 0, 3)) != 'WIN')
      {
        @shell_exec('find '.$main->home.'log/ -mtime +6 -and -type f -exec rm -fr {} \;');
      }
    $main->debug('program finished');
  }

# End

