<?php
//////////////////////////////////////////////////////////////////////
//
//      Projekt:   OutDatedSoftware (looks for outdated Software like typo3, joomla, wordpres.... and more
//      Datei:     filestuff.class.php
//      Version:   0.0.9
//      Datum:     19.04.2010
//      Author:    Martin Schiftan
//      Descr.:    Makes the most File-Funktions to read/write Files and make connections to external (Updates)
//      license:   private
//
//////////////////////////////////////////////////////////////////////


class FileStuff
  {
    public $useragent;
    public $checker;
    public $MainVersion;
    public $secure;
    public $postdata;
    public $method;
    public $url;
    public $port;
    public $infos;
    public $header;
    public $body;


    public function __construct($checker)
      {
        # download with witch function?
        $this->checker     = $checker;
        $this->MainVersion = $checker->config['mainversion'];
        $this->useragent   = "OutDatedSoftware Updater Version: ".$this->MainVersion;
        $this->secure      = 0;
        $this->method      = 'GET';
      }




    public function SetMethod($what)
      {
        if((!isset($what)) || (empty($what)))
          {
            $what = 'GET';
          }
        $this->method = $what;
      }


    public function GetRemoteData($url)
      {
        $_SERVER['PWD'] = $this->checker->home;
        $requeststring  = '';
        foreach($this->postdata as $key => $value)
          {
            if(($key != 'alt') && ($key != 'aktuell'))
              {
                $requeststring .= @$key.'='.@$value.'&';
              }
          }
        $url = $url.'?'.$requeststring;
        if((isset($this->checker->config['secure'])) && ($this->checker->config['secure'] == 1))
          {
            $this->secure = 1;
            $url          = str_replace('http://', 'https://', $url);
          }
        $this->url = $url;
        $disabled  = ini_get('disable_functions');
#
# use file_get_contents
        if((stripos($disabled, 'allow_url_fopen') === FALSE) && (stripos($disabled, 'file_get_contents') === FALSE) && ($this->secure != 1))
          {
            $postdaten = http_build_query($this->postdata);
            if((isset($requeststring)) && (!empty($requeststring)))
              {
                $ops  = array('http' => array('method' => $this->method, 'header' => "Accept-language: en\r\nContent-Type: application/x-www-form-urlencoded\r\nUser-Agent: ".$this->useragent."\r\n", 'timeout' => $this->checker->config['timeout'], 'content' => $postdaten));
              }
            else
              {
                $ops  = array('http' => array('method' => $this->method, 'header' => "Accept-language: en\r\nContent-Type: application/x-www-form-urlencoded\r\nUser-Agent: ".$this->useragent."\r\n", 'timeout' => $this->checker->config['timeout']));
              }
            $context  = stream_context_create($ops);
            if(!$data = @file_get_contents($url, false, $context))
              {
                if(!isset($http_response_header))
                  {
                    $http_response_header[] = 'connection refused';
                  }
                $data = 'via file_get_contents('.$url.'):  '.$this->GetHeaders(@$http_response_header);
              }
          }
#
# use curl (if filegetcontents are not allowed or need to verify ssl cert)
        elseif((extension_loaded('curl')) || ($this->secure == 1))
          {
            $data = $this->GetCurl();
            if((empty($data)) || (stripos($data, 'ERROR: ') !== FALSE))
              {
                $data = ' via CURL:  '.$this->GetHeaders($this->infos);
              }
          }
#
# or try to use wget over exec
        elseif((stripos($disabled, 'exec') === FALSE) && ($this->secure != 1))
          {
            $commando = 'wget -N -q --no-verbose "'.addslashes($url).'" --directory-prefix='.$this->checker->home.' --user-agent='.$this->useragent.' --timeout='.$this->checker->config['timeout'];
            shell_exec($commando);
            if(!isset($requeststring))
              {
                $data = 'via WGET:  try it self to see the ERROR:'."\n".$commando;
              }
            else
              {
                $vollname = explode('?', $url);
                if((isset($vollname[0])) && (!empty($vollname[0])))
                  {
                    $name = basename($vollname[0]);
                    $pfad = $this->checker->home.str_replace('outdated.software/en/', '', str_replace('www.outdated.software/en/', '', str_replace('outdated.software/de/', '', str_replace('www.outdated.software/de/', '', str_replace('?', '\?', str_replace('&', '\&', $url))))));
                    $pfad = str_replace('http://', '', str_replace('https://', '', $pfad));
                    shell_exec('mv '.$pfad.' '.$name);
                  }
                else
                  {
                    $name = basename($url);
                  }
                $data = 1;
              }
          }
        else
          {
            makelog('curlallowurl');
          }
        if((stripos($url, 'updates.tar.gz') !== FALSE) || (stripos($url, 'latest.tar.gz') !== FALSE) || (stripos($url, 'updates.tar.gz.md5') !== FALSE) || (stripos($url, 'md5.updates.tar.gz') !== FALSE))
          {
            if(stripos($data, 'ERROR: ') !== FALSE)
              {
                $data = $data;
              }
            elseif(!isset($name))
              {
                preg_match('#/(de|en)/(.*)\.tar\.gz\.md5#im', $url, $fund);
                if((isset($fund[2])) && (!empty($fund[2])))
                  {
                    $name = $fund[2].'.tar.gz.md5';
                  }
				else
				  {
	                preg_match('#/(de|en)/(.*)\.tar\.gz#im', $url, $fund);
    	            if((isset($fund[2])) && (!empty($fund[2])))
        	          {
            	        $name = $fund[2].'.tar.gz';
                	  }
				  }
                if(!$fp = fopen($this->checker->home.$name, 'wb+'))
                  {
                    $data = 'via CURL:  could not open '.$name.' --> '.$data;
                  }
				fwrite($fp, $data, strlen($data));
				fclose($fp);
				if(stripos($url, 'md5') === FALSE)
                  {
                    $data = 1;
                  }
              }
            else
              {
                # warning if skipping on
                die("diening here");
              }
          }
        if((!isset($data)) || (empty($data)))
          {
            if(empty($data))
              {
                $data = ' via file_get_contents, CURL, WGET.....:  ';
              }
            if(!isset($this->error))
              {
                warning('noremotedata', $data);
              }
          }
        return($data);
      }





    private function GetHeaders($header)
      {
        $dats   = '';
        if(is_array($header))
          {
             $errors = count($header);
          }
        elseif(empty($header))
          {
            $errors = 2;
          }
        for($i  = 0; $i < $errors; $i++)
          {
            if($i == 0)
              {
                $dats = "\nERROR: \n".$header[0]."\n";
              }
            elseif(isset($header[$i]))
              {
                $dats .= $header[$i]."\n";
              }
          }
        return($dats);
      }





    private function GetCurl()
      {
        if(stripos($this->url, 'https://') !== FALSE)
          {
            $this->port   = 443;
            $this->secure = 2;
          }
        else
          {
            $this->port   = 80;
            $this->secure = 0;
          }
        $curldata  = 0;
        $follow    = 1;
        $ch        = curl_init();
        curl_setopt($ch, CURLOPT_URL, $this->url);
        curl_setopt($ch, CURLOPT_FAILONERROR, 1);
        if(ini_get('safe_mode') != 'on')
          {
            $follow = 0;
          }
        if(ini_get('open_basedir') != 'on')
          {
            $follow = 0;
          }
        if($follow == 1)
          {
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
          }
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch, CURLOPT_PORT, $this->port);
        curl_setopt($ch, CURLOPT_TIMEOUT, $this->checker->config['timeout']);
        curl_setopt($ch, CURLOPT_USERAGENT, $this->useragent);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_REFERER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, $this->secure);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, $this->secure);
        if((isset($this->postdata)) && ((!empty($this->postdata)) || (is_array($this->postdata))))
          {
            $this->postdata = http_build_query($this->postdata);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $this->postdata);
          }
        $this->body     = curl_exec($ch);
        $this->infos    = curl_getinfo($ch);
        $this->infos[0] = $this->body;
        if(!empty($this->body))
          {
            $curldata = $this->body;
          }
        else
          {
            if($this->infos['http_code'] == 0)
              {
                $curldata       = 0;
                $this->header[] = curl_error($ch);
              }
            else
              {
                $curldata       = 0;
                $this->header[] = 'HTTP: Status-Code: '.$this->infos['http_code'];
              }
            $this->infos = $this->header;
          }
        return($curldata);
      }





    public function SetPostData($data)
      {
        $this->postdata = $data;
      }
  }
