<?php
//////////////////////////////////////////////////////////////////////
//
//      Projekt:   OutDatedSoftware (looks for outdated Software like typo3, joomla, wordpres.... and more
//      Datei:     statistics.class.php
//      Version:   1.0.8
//      Datum:     24.12.2013
//      Author:    Martin Schiftan
//      Descr.:    Sends Results to outdatedsoftware.eu for statistics when you have activated.
//      Descr.:    Privacy: the following Data was send to us:
//      Privatepolicy:  E-Mail and API-Key,
//      Privatepolicy:  The Results-> Dir/File as sha1-Sum (no Names....), Software-Modul like "wp-plugin-name", the current version, the old-version which was found.
//      license:   private
//
//////////////////////////////////////////////////////////////////////


class Statistics extends Run
  {
    public $error;
    public $config;
    public $home;
    public $alt;
    public $aktuell;

    public function __construct($config)
      {
        $this->error  = array();
        foreach($config['url'] as $key => $value)
          {
            $config['url'][$key] = str_replace('{$lang}', $config['lang'], $value);
          }
        $this->config = $config;
        $this->home   = $this->config['home'];
      }





    public function SendStats($aktuell, $alt)
      {
        $altes     = array();
        $aktuelles = array();
        if((!isset($aktuell)) || (!is_array($aktuell)))
          {
            $aktuell = array();
          }
        if((!isset($alt)) || (!is_array($alt)))
          {
            $alt = array();
          }
        $pfad = sha1($this->config['pfad']);
        foreach(@$alt as $key => $value)
          {
            if($this->config['private'] == 1)
              {
                $value['file']     = sha1($value['file']);
                $value['pfad']     = $pfad;
                $altes[sha1($key)] = $value;
              }
            else
             {
               $value['pfad'] = $this->config['pfad'];
               $altes[$key]   = $value;
             }
          }
        foreach(@$aktuell as $key => $value)
          {
            if($this->config['private'] == 1)
              {
                $value['file']         = sha1($value['file']);
                $value['pfad']         = $pfad;
                $aktuelles[sha1($key)] = $value;
              }
            else
              {
                $value['pfad']     = $this->config['pfad'];
                $aktuelles[$key]   = $value;
              }
           }
        $this->alt     = $altes;
        $this->aktuell = $aktuelles;
        $this->GetFile($this->config['url']['stats'], $this);
      }




    public function GetFile($url, $user=NULL)
      {
        $back   = 0;
        $out    = $this->config['wwwtimeout'] = 6;
        $get    = new FileStuff($this);
        $get->SetMethod('POST');
        if((isset($user)) && ($user !== NULL))
          {
            $data = array('key' => $this->config['key'], 'alt' => $this->alt, 'aktuell' => $this->aktuell);
                    $get->SetPostData($data);
          }
        $back = $get->GetRemoteData($url);
        return($back);
      }
  }
