<?php
//////////////////////////////////////////////////////////////////////
//
//      Projekt:   OutDatedSoftware (looks for outdated Software like typo3, joomla, wordpres.... and more
//      Datei:     outdatedsoftware.main.class.php
//      Version:   0.1.19
//      Datum:     29.01.2012
//      Author:    Martin Schiftan
//      Descr.:    Main Classess, Functions... find Version-Files and check them.
//      license:   private (Updates from Module-Version-Numbers only for paid users)
//
//////////////////////////////////////////////////////////////////////


class Run
  {

    public $config;
    public $home;
    public $error;
    public $languages;
    public $modulesclasse;
    public $updater;
    public $search;
    public $onlymodul;
    public $findfile;
    public $Modules;
    public $UpdateVersion;
    public $NumFiles;
    public $allfiles;
    public $pfad;
    public $ModulCount;
    public $SetMainVersion;
    public $filenames;
    public $uptodate;
    public $currentmodul;
    public $fund;
    public $file;
    public $counter;
    public $classconfig;
    public $retry = 0;

    public function __construct($config)
      {
        $this->counter               = 0;
                                       $this->debug('initial classes and plugins for programm');
                                       $this->debug('loading config and settings');
        $classconfig                 = new Config();
        $this->config                = array_merge($classconfig->GetConfig(), $config);
        $this->home                  = $this->GetHome();
                                       $this->debug('loading software-modules');
        $this->modulesclasse         = new ModulesClasses();
        $this->modulesclasse->config = $this->config;
        $this->modulesclasse->home   = $this->home;
        $this->classconfig           = $classconfig;
        $this->languages             = $classconfig->GetLanguages($this->config['color']);
                                       $this->debug('checking for updates');
        $this->updater               = new Updater($this->config, $this);
                                       $this->debug('updateting done');
        if((isset($this->config['createcronfile'])) && ($this->config['createcronfile'] == 1))
          {
            $this->UpdateVersion = $this->updater->GetCurrentVersion();
            if($this->GetCountModules() <= 0)
              {
                $this->fehler('nomodules');
                die();
              }
          }
        elseif($this->config['autoupdates'] == 1)
          {
            if(isset($_REQUEST[0]))
              {
                 $this->RunSelfUpdater();
              }
          }
      }





    public function SetHome($home)
     {
        if((!isset($home)) || (empty($home)))
          {
            $this->fehler('homenotset');
          }
        $this->home = $home;
     }





    public function GetHome()
      {
        if((!isset($this->home)) || (empty($this->home)))
          {
            $this->home = realpath(dirname(__FILE__).DIRECTORY_SEPARATOR.'..').DIRECTORY_SEPARATOR;
          }
        return($this->home);
      }





    public function RunSelfUpdater()
      {
        if((isset($this->config['createcronfile'])) && ($this->config['createcronfile'] == 1))
          {
            $this->UpdateVersion = $this->updater->GetCurrentVersion();
            return(1);
          }
        $this->debug('OLD software-modul-version: "'.$this->updater->GetCurrentVersion().'"');
        $this->updater->SelfUpdater();
        $this->debug('NEW software-modul-version: "'.$this->updater->GetCurrentVersion().'"');
        $this->UpdateVersion = $this->updater->GetCurrentVersion();
        return(1);
      }





    public function GetLanguages($color)
      {
        $return = $this->classconfig->GetLanguages($color);
        return($return);
      }





    public function GetFilesList($modul=NULL)
      {
        $b               = 0;
        $this->onlymodul = $modul;
        $this->findfile  = '';
        $spid            = getmypid();

        $cronjobfile     = $this->home.'cronjobfiles'.DIRECTORY_SEPARATOR;
        $filenames       = str_replace(DIRECTORY_SEPARATOR, '_', str_replace('\\', '_', $this->pfad));
        $cronjobsavefile = preg_replace('/[^a-zA-Z0-9_]/', '', $filenames);
        $cronjobfile     = $cronjobfile.$cronjobsavefile;
        $this->findfile  = $this->home.'log'.DIRECTORY_SEPARATOR.$spid.'.VersionFileList';
        if((isset($_REQUEST['cronjob'])) && (file_exists($cronjobfile.$cronjobsavefile)))
          {
            @copy($cronjobfile.$cronjobsavefile, $this->home.'log'.DIRECTORY_SEPARATOR.$spid.'.VersionFileList');
          }

        if((!isset($_REQUEST['cronjob'])) || (!file_exists($cronjobfile)))
          {
            $b        = 0;
            $files    = $this->GetFileNames($modul);
            $name     = '';
            $wname    = '';
            if($files <= 0)
              {
                $files = $this->updater->SelfUpdater();
                if($this->retry <= 0)
                  {
                    $this->retry = 1;
                    $this->LoadModules();
                    $files       = $this->GetFileNames($modul);
                  }
              }
            if($files !== 0)
              {
                foreach($files as $key => $value)
                  {
                    $value = basename($value);
                    if(strpos($name, ' '.$value) === FALSE)
                      {
                        $name .= '-name '.$value.' -or ';
                        $wname .= $this->pfad.'*'.$value.', ';
                        $gname[$value] = $value;
                      }
                  }
              }
            else
              {
                $this->fehler('nomodules', __LINE__);
                exit(1);
              }

            $blacklist      = $this->GetBlacklist();
            $name           = substr($name, 0, -5);
            if(strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')
              {
                $find   = 'dir '.str_replace('-name ', '', str_replace(' -or ', ',', $wname)).'/s /b';
                $find   = str_replace("  ", ' ', $find);
                $win    = 1;
              }
            else
              {
                $find   = 'find '.str_replace(" ", "\ ", $this->pfad).' -depth '.$name.$blacklist;
                $win    = 0;
              }
            $return = shell_exec($find.' > '.$this->findfile);
            $old    = 0;
          }
        elseif(isset($_REQUEST['cronjob']))
          {
            $cronjobfile     = $this->home.'cronjobfiles/';
            $filenames       = str_replace(DIRECTORY_SEPARATOR, '_', str_replace('\\', '_', $this->pfad));
            $cronjobsavefile = preg_replace('/[^a-zA-Z0-9_]/', '', $filenames);
            @copy($cronjobfile.$cronjobsavefile, $this->home.'log'.DIRECTORY_SEPARATOR.$spid.'.VersionFileList');
          }


        if(!file_exists($this->findfile))
          {
            if($this->config['usecronjob'] == 1)
              {
                $this->debug('cronjobfile '.$this->findfile.' not exists, run normal and searching for files...........');
                unset($_REQUEST['cronjob']);
                $this->config['usecronjob'] = 0;
                $files = $this->GetFilesList($modul);
              }
#            $this->fehler('cronjobfilenotexists', $this->findfile);
#            exit(1);
          }
        $return = @file_get_contents($this->findfile);
        $files  = explode("\n", $return);
        $count  = count($files);
        $b      = 0;
        for($i = 0; $i < $count; $i++)
          {
             if(!empty($files[$i]))
               {
                 $b++;
                 $files[$i] = $fund[] = $files[$i];
               }
           }
        $this->NumFiles = $b;
        if((isset($fund)) && (is_array($fund)))
          {
            $return = $fund;
          }
        else
          {
            $return = 0;
          }
       $this->allfiles = $return;
       if(!isset($_REQUEST['cronjob']))
         {
           @unlink($this->findfile);
         }
       return($return);
     }





    public function CheckFile()
      {
        $getsoftware = $this->LoadModules();
        $return      = '';
        if(!is_array($this->allfiles))
          {
            $return = 0;
          }
        else
          {
            $return = array();
            foreach($getsoftware as $key => $value)
              {
                foreach($this->allfiles as $fkey)
                  {
                    if(DIRECTORY_SEPARATOR == '\\')
                      {
                        $value['datei'] = str_replace('/', '\\\\', $value['datei']);
                        $fkey = rtrim($fkey);
                      }
                    else
                      {
                        $value['datei'] = addslashes($value['datei']);
                      }
                    if(preg_match('#(.*)'.$value['datei'].'$#i', $fkey, $funds))
                      {
                        if(((isset($this->onlymodul)) && ($this->onlymodul == $value['software'])) || ($this->onlymodul === NULL))
                          {
                            $return[] = array('modul' => $value['software'], 'file' => $fkey);
                          }
                      }
                  }
              }
          }
        return($return);
      }





    public function CheckFileVersion($file, $modul)
      {
        if(empty($file))
          {
            return(1);
          }
        if(!file_exists($file))
          {
            $this->debug('File not exists: '.$file.' -> skipping....');
            return(1);
          }
        $inhalt = @file_get_contents($file);
        if(empty($inhalt))
          {
            return(1);
          }
        $this->currentmodul = $modul;
        $this->file         = $file;
        $not                = 0;
        $suchstring         = addslashes(str_replace('{VERSION}', $this->search[$modul]['aktuell'], $this->search[$modul]['befehl']));
        $suchstring         = '/'.$this->SuchReplace($suchstring).'/iUm';
        $lines              = $this->search[$modul]['linecount'];
        $lts                = $this->search[$modul]['lts'];
        $treffer            = preg_match($suchstring, $inhalt, $fund2);
        if(($treffer) && ($lines <= 0) && (isset($fund2[1])))
          {
            $return                        = 1;
            $this->uptodate[$file]         = array('software' => $modul, 'file' => $this->EscapeFileName($file), 'old' => $this->search[$modul]['aktuell'], 'new' => $this->search[$modul]['aktuell']);
            $this->fund[$file]['uptodate'] = 1;
            unset($this->fund[$file]);
          }
        else
          {
            $inhalt = trim($inhalt);
            if(($lines > 0) && (stripos($file, 'wp-includes') === FALSE))
              {
                $not = 1;
                $fp  = fopen($this->home.'module'.DIRECTORY_SEPARATOR.$modul, 'r');
                $new = '';
                $alt = '';
                $lts = '';
                while($line = fgets($fp))
                  {
                    $versionen    = explode('|', $line);
                    if(isset($versionen[2]))
                      {
                        $versionen[2] = @str_replace("\r\n", "", @$versionen[2]);
                      }
                    $suchstring   = addslashes(@str_replace('{VERSION}', '(.*)', @$versionen[2]));
                    $suchstring   = '/'.$this->SuchReplace($suchstring).'/iUms';
                    $suchstring   = str_replace("\r\n", "", $suchstring);
                    $new          = $new.'.'.$versionen[0];
                    $lts          = (!empty($lts)) ? $lts.'.' : '';
                    $lts         .= (isset($versionen[3])) ? str_replace("\n", '', @$versionen[3]) : '';
                    $treffer      = preg_match($suchstring, $inhalt, $fund);
                    if(isset($fund[1]))
                      {
                        $fund[1] = $fund[1];
                        $alt     = $alt.'.'.trim($fund[1]);
                      }
                    else
                      {
                        $alt     = $alt.'.0';
                      }
                  }
                $new = substr($new, 1);
                $new = trim($new);
                $alt = substr($alt, 1);
                $alt = trim($alt);
                $alt = str_replace("\n", '', @$alt);
                if(($alt == '0.0') || ($alt == '0.0.0.0'))
                  {
                    $return = 1;
                    unset($this->fund[$file]);
                    return(1);
                  }
                if(($new === $alt) || ($lts === $alt))
                  {
                    $return                        = 1;
                    $this->uptodate[$file]         = array('software' => $modul, 'file' => $this->EscapeFileName($file), 'old' => $alt, 'new' => $new);
                    $this->fund[$file]['uptodate'] = 1;
                    unset($this->fund[$file]);
                    return(1);
                  }
                elseif($new != $lts)
                  {
                    $return                        = 0;
                    $this->fund[$file]['new']      = $lts;
                    $this->fund[$file]['old']      = $alt;
                    $this->fund[$file]['software'] = $modul;
                    $this->fund[$file]['file']     = $this->EscapeFileName($file);
                    @$this->fund[$file]['old']    .= $this->WarningOld(@$this->fund[$file]['old'], @$this->search[$modul]['aktuell']);
                    if(!empty($lts))
                      {
                        $news = $new.' / '.$lts.' LTS';
                      }
                    else
                      {
                        $news = $new;
                      }
                    $this->fund[$file]['new'] = $news;
                    return(0);
                  }
                elseif($new != $alt)
                  {
                    $return                        = 0;
                    $this->fund[$file]['new']      = $new;
                    $this->fund[$file]['old']      = $alt;
                    $this->fund[$file]['software'] = $modul;
                    $this->fund[$file]['file']     = $this->EscapeFileName($file);
                    @$this->fund[$file]['old']    .= $this->WarningOld(@$this->fund[$file]['old'], @$this->search[$modul]['aktuell']);
                    return(0);
                  }
              }
            if($not == 0)
              {
                $return                   = 0;
                $suchstring               = addslashes(str_replace('{VERSION}', '(.*)', $this->search[$modul]['befehl']));
                $suchstring               = '/'.$this->SuchReplace($suchstring).'/iUms';
                $treffer                  = preg_match($suchstring, $inhalt, $fund);
                $this->fund[$file]['new'] = $this->search[$modul]['aktuell'];

                if((isset($fund[0])) && (!empty($fund[0])) && (!isset($fund[1])))
                  {
                    $fund[1] = $fund[0];
                  }

                if(substr_count($this->search[$modul]['befehl'], '{VERSION}') >= 2)
                  {
                    if(!empty($fund[2]))
                      {
                        $fund[1] = @$fund[1].'.'.@$fund[2];
                      }
                    else
                      {
                        $this->uptodate[$file]         = array('software' => $modul, 'file' => $this->EscapeFileName($file), 'old' => $this->search[$modul]['aktuell'], 'new' => $this->search[$modul]['aktuell']);
                        $this->fund[$file]['uptodate'] = 1;
                        unset($this->fund[$file]);
                        return(1);
                      }
                  }
                if($this->search[$modul]['current'] != 0)
                  {
                    $this->fund[$file]['new'] = $this->search[$modul]['current'];
                  }
                if(!isset($fund[1]))
                  {
                    $return                   = 0;
                    $suchstring               = addslashes(str_replace('{VERSION}', '(.*)', $this->search[$modul]['befehl']));
                    $suchstring               = '/'.$this->SuchReplace($suchstring).'/iUms';
                    $treffer                  = preg_match($suchstring, $inhalt, $fund);
                    $this->fund[$file]['new'] = $this->search[$modul]['aktuell'];
                    if(!isset($fund[1]))
                      {
                        # Versions-File matchts, but not the Regex for Version-String
                        $fund[1] = 'unknown';
                      }
                  }
                 if((@$fund[1] == $this->search[$modul]['aktuell']))
                   {
                     if($this->config['listupdated'] == 1)
                       {
                         $this->uptodate[$file]        = array('software' => $modul, 'file' => $this->EscapeFileName($file), 'old' => $this->search[$modul]['aktuell'], 'new' => $this->search[$modul]['aktuell']);
                         $this->fund[$file]['uptodate'] = 1;
                         $return                        = 0;
                         $this->fund[$file]['new']      = $this->search[$modul]['aktuell'];
                         $this->fund[$file]['old']      = $this->search[$modul]['aktuell'];
                         $this->fund[$file]['software'] = $modul;
                         $this->fund[$file]['file']     = $this->EscapeFileName($file);
                         @$this->fund[$file]['old']    .= $this->WarningOld(@$this->fund[$file]['old'], @$this->search[$modul]['aktuell']);
                         return(0);
                       }
                     else
                       {
                         $this->uptodate[$file]        = array('software' => $modul, 'file' => $this->EscapeFileName($file), 'old' => $this->search[$modul]['aktuell'], 'new' => $this->search[$modul]['aktuell']);
                         $this->fund[$file]['uptodate'] = 1;
                         return(1);
                       }
                  }
                if(strlen($fund[1]) >= 20)
                  {
                    unset($this->fund[$file]);
                    return(1);
                  }
                if(($modul == 'owncloud6') && ($fund[1] == 'Enterprise'))
                  {
                    unset($this->fund[$file]);
                    return(1);
                  }
                if(stripos($modul, 'owncloud') !== FALSE)
                  {
                    $preg = preg_match('/vendor = \'nextcloud\';/iUm', $inhalt, $funds);
                    if($preg == 1)
                      {
                        unset($this->fund[$file]);
                        $return = 1;
                        # is not OWNcloud, it is NEXTcloud
                      }
                  }
                elseif(stripos($modul, 'nextcloud') !== FALSE)
                  {
                    $preg = preg_match('/vendor = \'owncloud\';/iUm', $inhalt, $funds);
                    if($preg == 0)
                      {
                        $preg2 = preg_match('/vendor = \'nextcloud\';/iUm', $inhalt, $funds);
                      }
                    if(($preg == 1) || (($preg == 0) && ($preg2 == 0)))
                      {

                        unset($this->fund[$file]);
                        $return = 1;
                        # is not NEXTcloud > 10, it is OWNcloud
                      }
                  }
                if($modul == 'revive-adserver')
                  {
                    if(!preg_match('/Revive Adserver/iUm', $inhalt))
                      {
                        unset($this->fund[$file]);
                        $return = 1;
                      }
                  }
                elseif($modul == 'vanilla')
                  {
                    if(!preg_match('/x-version-scheme/iUms', $inhalt))
                      {
                        unset($this->fund[$file]);
                        $return = 1;
                      }
                  }

                $this->fund[$file]['old']      = $fund[1];
                $this->fund[$file]['software'] = $this->search[$modul]['software'];
                if(($fund[1] == 'unknown') && (!isset($_REQUEST['debug'])))
                  {
                    $return = 1;
                    unset($this->fund[$file]);
                  }
              }
            if(!isset($this->fund[$file]['old']))
              {
                $this->fund[$file]['old'] = '';
              }
            if(strpos(@$this->fund[$file]['old'], '<?') !== FALSE)
              {
                $return = 1;
                unset($this->fund[$file]);
              }
            @$this->fund[$file]['old'] .= $this->WarningOld(@$this->fund[$file]['old'], @$this->search[$modul]['aktuell']);
            if(!empty($lts))
              {
                if(@$this->fund[$file]['old'] == @$this->search[$modul]['lts'])
                  {
                    $return                        = 1;
                    $this->uptodate[$file]         = array('software' => $modul, 'file' => $this->EscapeFileName($file), 'old' => $this->search[$modul]['aktuell'], 'new' => $this->search[$modul]['aktuell']);
                    $this->fund[$file]['uptodate'] = 1;
                    if(isset($this->fund[$file]))
                      {
                        unset($this->fund[$file]);
                      }
                  }
              }
            if(!isset($return))
              {
                $return                        = 0;
                $this->fund[$file]['new']      = 'unbekannt';
                $this->fund[$file]['software'] = $this->search[$modul]['software'];
                $this->fund[$file]['old']      = 'konnte nicht ermitteln....';
              }
          }
        $this->fund[$file]['old']  = str_replace("\n", '', @$this->fund[$file]['old']);
        $this->fund[$file]['file'] = $this->EscapeFileName($file);
        if(($this->config['listupdated'] == 1) && (isset($this->uptodate[$file])))
          {
            $this->fund[$file]             = $this->uptodate[$file];
            $this->fund[$file]['uptodate'] = 1;
            $return                        = 0;
          }
        return($return);
      }





    private function EscapeFileName($file)
      {
        $return = $file;
        if((isset($file)) && (!empty($file)))
          {
            if((substr_count($this->search[$this->currentmodul]['datei'], DIRECTORY_SEPARATOR) > 1) || (stripos($this->search[$this->currentmodul]['software'], 'owncloud') !== FALSE) || (stripos($this->search[$this->currentmodul]['software'], 'nextcloud') !== FALSE))
              {
                $return = str_replace($this->search[$this->currentmodul]['datei'], '', $file).DIRECTORY_SEPARATOR;
              }
          }
        return($return);
      }





    public function fehler($msg, $var=NULL)
      {
        global $n;
        $msg = @str_replace('{HOLD}', $var, $GLOBALS['languages'][$msg]);
        if((!isset($this->config['ignoreupdate'])) || ($this->config['ignoreupdate'] == 1))
          {
            echo $n."\033[32mWARNING:\033[0m".$n.$msg.$n.$n;
          }
        else
          {
            exit($n.$n."\033[31mERROR:\033[0m".$n.$msg.$n.$n);
          }
      }



    public function debug($msg)
      {
        global $n;
        if((isset($this->config['debug'])) && ($this->config['debug'] == 1))
          {
            echo $n."[".date('d.m.Y H:i:s O').']   '.$msg.$n.$n;
          }
      }




    public function GetResults($file)
      {
        if(isset($this->fund[$file]))
          {
            $this->counter++;
            return($this->fund[$file]);
          }
      }




    public function GetResultsUpToDate()
      {
        if(isset($this->uptodate))
          {
            $return = $this->uptodate;
          }
        else
         {
           $return = 0;
         }
        return($return);
      }

   public function GetNumOld()
     {
       return($this->counter);
     }



    public function GetResultsOld()
      {
        if(isset($this->fund))
          {
            $return = array();
            foreach($this->fund as $key => $value)
              {
                if(isset($value['software']))
                  {
                    $return[$key] = $value;
                  }
              }
            return($return);
          }
      }




    private function WarningOld($alt, $new)
      {
        $return   = '';
        $check    = version_compare($alt, $new);
        if($check == 1)
          {
            $return = ' Installed Version is newer';
            $this->fund[$this->file]['newer'] = 1;
            if((isset($this->currentmodul)) && (stripos($this->currentmodul, 'joomla') !== FALSE))
              {
                $return .= ' Installed Joomla is a Mambo?';
              }
          }
        return($return);
      }





    private function GetFileNames($modul)
      {
        $this->LoadModules();
        $return          = 0;
        $this->filenames = $this->modulesclasse->GetModulesFileNames();
        if((isset($modul)) && ($modul !== NULL))
          {
            $return = array($this->search[$modul]['datei']);
          }
        else
          {
            if((isset($this->filenames)) && (is_array($this->filenames)))
              {
                $return = $this->filenames;
              }
          }
        return($return);
      }





    private function GetBlacklist()
      {
        $blacklist = '';
        if(isset($_REQUEST['blacklist']))
          {
            $return = explode('|', $_REQUEST['blacklist']);
            if(!is_array($return))
              {
                $this->fehler('blacklistfalse');
              }
             foreach($return as $key)
               {
                  if(!empty($key))
                    {
                      $blacklist .= '| grep -vi '.$key;
                      # ToDo, later with expurge, in the meantime, long with grep -v .... $lbacklist .= ' -o '
                    }
               }
          }
        return($blacklist);
      }





    public function sendStats($aktuell, $alt)
      {
        if((isset($this->config['stats'])) && ($this->config['stats'] == 1))
          {
            $aktuell = $this->GetResultsUpToDate();
            $alt     = $this->GetResultsOld();
            if(class_exists('Statistics'))
              {
                $this->config['pfad'] = $this->pfad;
                $stats   = new Statistics($this->config);
                $sende   = $stats->SendStats($aktuell, $alt);
              }
            else
              {
                $this->debug('Statistic class not loaded, so not sending stats...');
              }
          }
        return(1);
      }




    private function SuchReplace($suchstring)
      {
         $suchstring = str_replace('[', '\[', str_replace(']', '\]', $suchstring));
         $suchstring = str_replace('$', '\$', $suchstring);
         $suchstring = str_replace('-\$-', '$', $suchstring);
         $suchstring = str_replace('\\"', '\"', $suchstring);
         $suchstring = str_replace('/', '\/', $suchstring);
         $suchstring = str_replace('(', '\(', $suchstring);
         $suchstring = str_replace(')', '\)', $suchstring);
         $suchstring = str_replace("\\n", "\n", $suchstring);
         $suchstring = str_replace('+\$', '+$', $suchstring);
         $suchstring = str_replace('\[0-9.\]', '[0-9.]', $suchstring);
         $suchstring = str_replace('\[0-9\]', '[0-9]', $suchstring);
         $suchstring = str_replace('\\.', '\.', $suchstring);
         $suchstring = str_replace('\(.*\)', '(.*)', $suchstring);
         if(substr($suchstring, -1) == "\n")
           {
             $suchstring = substr($suchstring, 0, -1);
           }
         $suchstring = str_replace('-n-', "\n", $suchstring);
         return($suchstring);
      }





    private function LoadModules()
      {
        $this->search = $this->modulesclasse->GetLoadedModules();
        return($this->search);
      }





    public function GetModules()
      {
        $this->StartClassModules();
        $this->Modules    = $this->modulesclasse->GetModules();
        $this->ModulCount = $this->modulesclasse->GetModulesCount();
        return($this->Modules);
      }





    public function GetModulesNames()
      {
        $this->StartClassModules();
        $this->ModulNames = $this->modulesclasse->GetModulesNames();
        return($this->ModulNames);
      }

    private function StartClassModules()
      {
        if(!isset($this->modulesclasse))
          {
            $this->home                  = $this->GetHome();
            $this->modulesclasse         = new ModulesClasses();
            $this->modulesclasse->config = @$this->config;
            $this->modulesclasse->home   = $this->GetHome();
          }
      }




    public function GetCountModules()
      {
        if(!isset($this->ModulCount))
          {
            $this->GetModules();
          }
        if(isset($this->ModulCount))
          {
            return($this->ModulCount);
          }
      }





    public function GetNumFiles()
      {
        return($this->NumFiles);
      }





    public function GetModulesVersion()
      {
        if(!isset($this->UpdateVersion))
          {
            $this->RunSelfUpdater();
          }
        return($this->UpdateVersion);
      }





    public function GetMainVersion()
      {
        return($this->config['mainversion']);
      }

    public function SetMainVersion($newmainversion)
      {
        $this->config['mainversion'] = $newmainversion;
      }

  }

