<?php
//////////////////////////////////////////////////////////////////////
//
//      Projekt:   OutDatedSoftware (looks for outdated Software like typo3, joomla, wordpres.... and more
//      Datei:     filestuff.class.php
//      Version:   0.0.9
//      Datum:     19.04.2012
//      Author:    Martin Schiftan
//      Descr.:    Makes the most File-Funktions to read/write Files and make connections to external (Updates)
//      license:   private
//
//////////////////////////////////////////////////////////////////////

class ModulesClasses
  {
    public $home;
    public $filenames;
    public $search;
    public $ModulCount;
    public $config;
    public $error;


    public function __construct()
      {
        global $config;
        return(0);
      }



   public function GetLoadedModules()
     {
        return($this->LoadModules());
     }





    private function LoadModules()
      {
        if(!$fd = @opendir($this->home.'module'.DIRECTORY_SEPARATOR))
          {
            if(!file_exists($this->home.'module'.DIRECTORY_SEPARATOR))
              {
                $updater = new Updater($this->config, $this);
                $updater->UpdateModules();
              }
            else
              {
                $this->RunSelfUpdater();
              }
            if(!$fd = @opendir($this->home.'module'.DIRECTORY_SEPARATOR))
              {
                $this->fehler('modulesdir');
                exit(1);
              }
          }
        while($files = readdir($fd))
          {
            if(($files != '..') && ($files != '.'))
              {
                $software  = file_get_contents(@$this->home.'module'.DIRECTORY_SEPARATOR.$files);
                if(!isset($software))
                  {
                    $this->fehler('modulenotloaded', $this->home.'module'.DIRECTORY_SEPARATOR.$files);
                  }
                $versionen = explode('|', $software);
                if((!isset($versionen[1])) && ($_SERVER['argv']['1'] !== 'update'))
                  {
                    $this->fehler('modulebroken', $files);
                  }
                elseif((!isset($versionen[1])) && ($_SERVER['argv']['1'] == 'update'))
                  {
                     continue;
                  }
                $lines = substr_count($software, "\n");
                $linecount = $lines;
                if($lines >= 1)
                  {
                    $fp          = fopen($this->home.'module'.DIRECTORY_SEPARATOR.$files, 'r');
                    $linecount   = 0;
                    while($line = fgets($fp))
                      {
                        $linecount++;
                        $ex      = explode('|', $line);
                        if(!isset($version))
                          {
                            $version = $ex[0];
                          }
                        else
                          {
                            $version .= '.'.$ex[0];
                          }
                        if((!isset($lts)) && (!empty($ex[3])))
                          {
                            $lts = @$ex[3];
                          }
                        elseif(!empty($ex[3]))
                          {
                            $lts .= '.'.@$ex[3];
                          }
                      }
                    if((!isset($lts)) || (empty($lts)))
                      {
                        $lts = '';
                      }
                    $versionen[0] = $version;
                    $versionen[3] = $lts;
                    unset($ex);
                    unset($version);
                    unset($lts);
                  }
                $aktuelle  = $versionen[0];
                $dateien   = @$versionen[1];
                $befehl    = @$versionen[2];
                if((isset($versionen[3])) && (!empty($versionen[3])))
                  {
                    $lts   = (isset($versionen[3])) ? str_replace("\n", '', $versionen[3]) : '';
                    $lts   = str_replace(' ', '', $lts);
                  }
                else
                  {
                    $lts = '';
                  }
                if(!empty($lts))
                  {
                    $current = @$aktuelle.' / '.$lts.' LTS';
                    if(isset($_REQUEST['list']))
                      {
                        $aktuelle = $current;
                      }
                  }
                else
                  {
                    $current = 0;
                  }
                $this->filenames[] = $dateien;
                $return[$files]    = array('software' => $files, 'aktuell' => $aktuelle, 'datei' => $dateien, 'befehl' => $befehl, 'lts' => $lts, 'current' => $current, 'linecount' => $linecount);
                unset($lts);
                unset($befehl);
                unset($versionen);
              }
          }
        if(!isset($return))
          {
            $return = array();
          }
        else
          {
            ksort($return);
          }
        $this->search = $return;
        return($return);
      }



    public function GetModulesCount()
      {
        if(!isset($this->search))
          {
            $this->LoadModules();
          }
        if(isset($this->search))
          {
            $this->ModulCount = @count($this->search);
            return($this->ModulCount);
          }
      }



    public function GetModules()
      {
        if(!isset($this->search))
          {
            $this->LoadModules();
          }
        return($this->search);
      }




    public function GetModulesNames()
      {
        if((!isset($this->search)) || ($this->ModulCount <= 0))
          {
            $this->LoadModules();
          }
        if(isset($this->search))
          {
            foreach($this->search as $key => $value)
              {
                $return[$key] = $key;
              }
            return($return);
          }
        else
          {
            $this->fehler('nomodules', __LINE__);
          }
       return($return);
      }


    public function fehler($msg, $var=NULL)
      {
        global $n;
        $msg = @str_replace('{HOLD}', $var, $GLOBALS['languages'][$msg]);
        if((!isset($this->config['ignoreupdate'])) || ($this->config['ignoreupdate'] !== 1))
          {
            exit($n."\033[32mWARNING:\033[0m".$n.$msg.$n.$n);
          }
        else
          {
            echo $n.$n."\033[31mERROR:\033[0m".$n.$msg.$n.$n;
          }
      }



    public function GetModulesFileNames()
      {
        return(@$this->filenames);
      }
  }
